minsize = 100; 
maxsize = 1000; 
dataName={'amazon'};%'youtube', , 'dblp', 'lj', 'orkut', 'friendster'
hyperbolicLL = nan(length(dataName),1);
blockLL = nan(length(dataName),1);

parfor dataNameIndex = 1:length(dataName)
    tic
    d = char(dataName(dataNameIndex));
    disp(['--------------- ' d ' ---------------']);
    try
        dataset = load(['../data/' d '_' int2str(minsize) '_' int2str(Inf) '.mat']);
        try
            result = load(['../results/result_multiComm_'  d '_' int2str(minsize) '_' int2str(maxsize) '_1sample500_v2.mat']);
        catch
            disp('Alternative sample');
            result = load(['../results/result_multiComm_'  d '_' int2str(minsize) '_' int2str(maxsize) '_1sample500.mat']);
        end
        comms = repmat(struct('p1',0), length(dataset.commVec), 1 );
        for i=1:length(result.order)
            comms(i).p1=length(dataset.commVec{result.order(i)})-1;
            comms(i).p2=length(dataset.commVec{result.order(i)})-1;
            comms(i).paramType='H,gamma';
            comms(i).members = dataset.commVec{result.order(i)};
            comms(i).model = makeCommunity(length(comms(i).members),comms(i).p1, comms(i).p2 , getCondition(comms(i).paramType));
        end
        blockLL(dataNameIndex) = computeLLOfGraph(dataset.graph,comms);
        hyperbolicLL(dataNameIndex) = computeLLOfGraph(dataset.graph,result.res);
        disp([d ':']);
        fprintf('=> LL of block model %i\n',blockLL(dataNameIndex));
        fprintf('=> LL of hyperbolic model %i\n',hyperbolicLL(dataNameIndex));
    catch e
        disp(e.message);
    end
    toc     
end
save(['../results/result_LLs_amazon_' int2str(minsize) '_' int2str(maxsize) '_1sample500_v2.mat'], 'blockLL', 'hyperbolicLL', 'dataName');
disp('Done.');
diary off;
