minsize = 100; 
maxsize = 1000; 
dataName={'amazon', 'dblp', 'friendster','lj', 'orkut', 'youtube'}; 
hyperbolicLL = nan(length(dataName),1);
hyComLL = nan(length(dataName),1);
blockLL = nan(length(dataName),1);

parfor dataNameIndex = 1:length(dataName)
    tic
    d = char(dataName(dataNameIndex));
    disp(['--------------- ' d ' ---------------']);
    try
        dataset = load(['../data/' d '_' int2str(minsize) '_' int2str(Inf) '.mat']);
        try
            result = load(['../results/result_multiComm_'  d '_' int2str(minsize) '_' int2str(maxsize) '_1sample500_v2.mat']);
            hyComResult = load(['../results/result_hyComModel_correctSample_'  d '_' int2str(minsize) '_' int2str(maxsize) '_1sample500_v2.mat']);
        catch
            disp('Alternative sample');
            result = load(['../results/result_multiComm_'  d '_' int2str(minsize) '_' int2str(maxsize) '_1sample500.mat']);
            hyComResult = load(['../results/result_hyComModel_correctSample_'  d '_' int2str(minsize) '_' int2str(maxsize) '_1sample500_v2.mat']);
        end
        
        blockComms = repmat(struct('p1',0), length(dataset.commVec), 1 );
        for l=1:length(result.order)
            blockComms(l).p1=length(dataset.commVec{result.order(l)})-1;
            blockComms(l).p2=length(dataset.commVec{result.order(l)})-1;
            blockComms(l).paramType='H,gamma';
            blockComms(l).members = dataset.commVec{result.order(l)};
            blockComms(l).model = makeCommunity(length(blockComms(l).members),blockComms(l).p1, blockComms(l).p2 , getCondition(blockComms(l).paramType));
        end
        blockLL(dataNameIndex) = computeLLOfGraph(dataset.graph,blockComms);
        hyComLL(dataNameIndex) = computeLLOfGraph(dataset.graph,hyComResult.res);
        hyperbolicLL(dataNameIndex) = computeLLOfGraph(dataset.graph,result.res);
        disp([d ':']);
        fprintf('=> LL of hyCom model %i\n',hyComLL(dataNameIndex));
        fprintf('=> LL of block model %i\n',blockLL(dataNameIndex));
        fprintf('=> LL of hyperbolic model %i\n',hyperbolicLL(dataNameIndex));

        %likelihood ratio test: D = 2 * (alternativeModel - nullModel)
        D = 2*(hyperbolicLL(dataNameIndex)-blockLL(dataNameIndex));
        fprintf('LL ratio hyperbolic vs. block: %.1f\n',D);
        D = 2*(hyperbolicLL(dataNameIndex)-hyComLL(dataNameIndex));
        fprintf('LL ratio hyperbolic vs. hyCom: %.1f\n',D);
        D = 2*(hyComLL(dataNameIndex)-blockLL(dataNameIndex));
        fprintf('LL ratio hyCom vs. block: %.1f\n',D);
    catch e
        disp(e.message);
    end
    toc     
end

%oldResult = load('../results/result_LLs_hyComModelFast_100_1000_1sample500_v2.mat');

LLratioBlock = 2*(hyperbolicLL-blockLL);
LLratioHyCom = 2*(hyperbolicLL-hyComLL);
LLratioHyComBlock = 2*(hyComLL-blockLL);
save(['../results/result_LLs_hyComModel_correctSample_' int2str(minsize) '_' int2str(maxsize) '_1sample500_v2.mat'], ...
    'hyComLL', 'hyperbolicLL', 'blockLL', 'LLratioBlock','LLratioHyCom', 'LLratioHyComBlock', 'dataName');
disp('Done.');
diary off;
