synthetic = false;
clear comms;

if synthetic
    graph = zeros(101,101); 
    lengths = [40, 30, 50, 40];
    offsets = [1, 11, 31,61];
    Hs =      [2,  4,  4,  8];
    gammas = [15, 10, 10, 15];

    for i=1:length(lengths)
        comms(i).members=offsets(i):offsets(i)+lengths(i)-1;
        comms(i).paramType='H,gamma';
        c = makeCommunity(lengths(i), Hs(i), gammas(i), getCondition(comms(i).paramType));
        graph(comms(i).members,comms(i).members) = graph(comms(i).members,comms(i).members) | c;
        comms(i).p1 = 0;
        comms(i).p2 = floor(lengths(i)/2-1);
    end
    for i=1:length(lengths)
        [comms(i).comm, order] = degree_ord(graph(comms(i).members,comms(i).members));
        comms(i).members = comms(i).members(order);
    end
    
%     figure;imagesc(graph);
%     [ordGraph,orderOfGraph] = degree_ord(graph);
% 
%     ordComms = comms;
%     for i=1:length(comms)
%         ordComms(i).members = [];
%         for j = comms(i).members, 
%             ordComms(i).members(end+1) = find(orderOfGraph == j);
%         end
%     end
%     figure;imagesc(ordGraph);
    
    commIdxs = 1:length(comms);
    globalLLs = [];
    meanLLs = [];
    globalLLs2 = [];
    meanLLs2 = [];
    for order = transpose(perms(commIdxs))
        transpose(order)
        [res] = improveModel(graph,comms(order),true);%false means globalOutsideDensity off
        meanLLs(end+1) = mean([res(:).LL]);
        globalLLs(end+1)=computeLLOfGraph(graph,res);
        [res2] = improveModel(graph,comms(order),true);%true means globalOutsideDensity on
        meanLLs2(end+1) = mean([res2(:).LL]);
        globalLLs2(end+1)=computeLL(getCommunityStatisticsForMultipleCommunities(graph,res2));
    end
    figure;plot(globalLLs);hold on;plot(meanLLs);plot(globalLLs2);plot(meanLLs2);
    legend('global LL', 'mean local LL', 'global LL(uniform outside density)', 'mean local LL(uniform outside density)','Location','southwest');
else
    minsize = 100; 
    maxsize = 1000; 
    diary(['../results/result_multiComm_diary_' int2str(minsize) '_' int2str(maxsize) '_sample500_v2.out']);
    dataName={'youtube','lj', 'orkut', 'friendster''amazon' ,'dblp'};
    globalOutsideDensity =  [true];
    numSamples = 500;
    
    for LLtype = globalOutsideDensity
        fprintf('^^^^^ use global outside density: %i ^^^^^\n', LLtype);
        parfor dataNameIndex = 1:length(dataName)
            tic
            d = char(dataName(dataNameIndex));
            disp(['--------------- ' d ' ---------------']);
%             try
                dataset = load(['../data/' d '_' int2str(minsize) '_Inf.mat']);
                comms = repmat(struct('p1',0), length(dataset.commVec), 1 );
                for i=1:length(dataset.commVec)
                    comms(i).p2=floor(length(dataset.commVec{i})/2-1);
                    comms(i).paramType='H,gamma';
                    [comms(i).comm, ord] = degree_ord(dataset.communities{i});
                    comms(i).members = dataset.commVec{i}(ord);
                end
                
                [commSizes,commIndices] = sort(cellfun('length', dataset.commVec), 'ascend');% small ones first
                firstTooBigCommunity = find(commSizes > maxsize, 1);
                commIndices = commIndices(1:(firstTooBigCommunity-1));
                randOrder = randperm(length(commIndices));
                samplesToUse = numSamples;
                if numSamples>length(randOrder) 
                   samplesToUse = length(randOrder); 
                end
                order = commIndices(randOrder(1:samplesToUse));
                %order = randperm(length(dataset.communities));
                %load(['result_multiComm_' d int2str(LLtype) '.mat']);
                [res] = improveModel(dataset.graph,comms(order), LLtype);
                fprintf('=> found mean local LL of %i\n',mean([res(:).LL]));
                %globalLL = computeLL(getCommunityStatisticsForMultipleCommunities(dataset.graph,res));
                %fprintf('=> found global LL of %i\n',globalLL);
                parsave(['../results/result_multiComm_'  d '_' int2str(minsize) '_' int2str(maxsize) ...
                    '_' int2str(LLtype) 'sample500_v2.mat'], res, order);
%             catch e
%                 disp('Skip because of:');
%                 disp(e.message);
%             end
            disp(['Dataset ' d ' took:']);
            toc
        end
    end
    disp('Done.');
    diary off;
end

