if ~exist('B', 'var')
    load('../data/youtube_swapRand100.mat');
end

diary('../results/result_swapRand_diary.out');
minsize = 100; 
maxsize = 1000; 

load('../data/youtube_100_Inf.mat');
comms = repmat(struct('p1',0), length(commVec), 1 );
for i=1:length(commVec)
    comms(i).p2=floor(length(commVec{i})/2-1);
    comms(i).paramType='H,gamma';
    [comms(i).comm, ord] = degree_ord(communities{i});
    comms(i).members = commVec{i}(ord);
end
[commSizes,commIndices] = sort(cellfun('length', commVec), 'ascend');% small ones first
firstTooBigCommunity = find(commSizes > maxsize, 1);
commIndices = commIndices(1:(firstTooBigCommunity-1));
randOrder = randperm(length(commIndices));
order = commIndices(randOrder);

blockComms = repmat(struct('p1',0), length(commVec), 1 );
for i=1:length(order)
    blockComms(i).p1=length(commVec{order(i)})-1;
    blockComms(i).p2=length(commVec{order(i)})-1;
    blockComms(i).paramType='H,gamma';
    blockComms(i).members = commVec{order(i)};
    blockComms(i).model = makeCommunity(length(blockComms(i).members),blockComms(i).p1, blockComms(i).p2 , getCondition(blockComms(i).paramType));
end

globalLL = nan(length(B),1);
blockLL = nan(length(B),1);
time = nan(length(B),1);

parfor g = 1:length(B)
    graph = B{g};
    fprintf('Start graph %i ... ', g);
    tic
    [res] = improveModel(graph, comms(order), LLtype);
    fprintf('done.\n');
    time(g) = toc
    fprintf('Computing LL\n');
    globalLL(g) = computeLLOfGraph(graph,res);
    blockLL(g) = computeLLOfGraph(graph,blockComms);
    parsave(['../results/result_swapRand_graph' int2str(g) '.mat'], res, ...
        struct('order',order, 'globalLL', globalLL(g), 'blockLL', blockLL(g), 'time', time(g)));
end

save('../results/result_swapRand_allLLs.mat', 'globalLL', 'blockLL', 'time');
    